<?php
/**
 * FuzeWorks PHPMailer Wrapper
 *
 * The FuzeWorks PHP FrameWork
 *
 * Copyright (C) 2013-${YEAR} i15
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * @author    i15
 * @copyright Copyright (c) 2013 - ${YEAR}, i15. (http://i15.nl)
 * @license   https://opensource.org/licenses/MIT MIT License
 *
 * @link  https://i15.nl
 * @since Version 1.3.0
 *
 * @version Version 1.3.0
 */

namespace FuzeWorks\Mailer;
use FuzeWorks\Config;
use FuzeWorks\Factory;
use FuzeWorks\iLibrary;
use FuzeWorks\Priority;
use PHPMailer\PHPMailer\PHPMailer;

class PHPMailerWrapper extends PHPMailer implements iLibrary
{

    public function __construct()
    {
        parent::__construct(true);

        // Load the basic requirements for every request
        /** @var Config $config */
        $config = Factory::getInstance('config');
        $libraryPath = dirname(__FILE__);
        $config->addComponentPath($libraryPath, Priority::LOWEST);

        // Load config and apply to PHPMailer
        $mailerCfg = $config->get("mailer");
        foreach ($mailerCfg->toArray() as $key => $val)
        {
            if (str_contains($key, '()'))
            {
                $key = str_replace('()', '', $key);
                if (is_array($val))
                    $this->{$key}(...$val);
                elseif (empty($val))
                    $this->{$key}();
                else
                    $this->{$key}($val);
            }
            else
                $this->{$key} = $val;
        }

    }

    /**
     * @inheritDoc
     */
    public function getClassesPrefix(): ?string
    {
        return null;
    }

    /**
     * @inheritDoc
     */
    public function getSourceDirectory(): ?string
    {
        return null;
    }
}